    
if (!window.XMLHttpRequest) {
    if (window.ActiveXObject) {
        window.XMLHttpRequest = function() { return new ActiveXObject("Microsoft.XMLHTTP") }
    } else {
        window.XMLHttpRequest = function() { throw new Error('No ajax object found') }
    }
}

// the gift to frIEnds...
/**
    The func is to be defined as for O, FF, S:
        - it is given event parameter
        - this points to the Node the event is dispatched on
        - e.preventDefault works
*/

window.__$$eventManager = {
    genid : 0,
    events : {}
};

function addEvent(node, kind, func, capture) {
    if (node.addEventListener) {
        node.addEventListener(kind, func, !!capture);
    }
    else if (node.attachEvent) {
        node.attachEvent('on'+kind, function() {
            var e = window.event;
            e.preventDefault = function() {
                this.returnValue = false;
            }
            func.__wrapperFunction__ = arguments.callee; // check if works 1/2
            func.call(node, e);
        })
        window.__$$eventManager.events[window.__$$eventManager.genid++] = [
            node, kind, func, capture
        ];
    }
};

function removeEvent(node, kind, func, capture) {
    if (node.removeEventListener) {
        node.removeEventListener(kind, func, !!capture);
    }
    else if (node.detachEvent && func.__wrapperFunction__) {
        node.detachEvent('on'+kind, func.__wrapperFunction__); // check if works 2/2
    }
};

window.addEvent(window, 'unload', function() {
    for (id in window.__$$eventManager.events) {
        window.removeEvent.apply(null, window.__$$eventManager.events[id]);
    }
});




var getElementsByClassName = function (className) {
    var found = [];
    var all = this.all || this.getElementsByTagName('*');
    var regexp = new RegExp('(^|\\s)'+className+'(\\s|$)');
    for (var i=0, el; el = all[i]; ++i) {
        if (el.className.match(regexp)) { found.push(el) };
    }
    return found;
}
    
if (!document.getElementsByClassName) {
    document.getElementsByClassName = getElementsByClassName;
}


/**
    Based on: 
    http://snipplr.com/view/13523/getcomputedstyle-for-ie/
    http://erik.eae.net/archives/2007/07/27/18.54.15/#comment-102291
*/
if (!window.getComputedStyle) {

    var UNITS_BUT_PX = /^\d+(\.\d+)?(em|ex|%|in|mm|cm|pt|pc){1}$/i;
    //var PIXEL = /^\d+(px)?$/i;
    
    function pixelizeDimension(element, value) {

        if (UNITS_BUT_PX.test(value)) {
            var style = element.style.left;
            var runtimeStyle = element.runtimeStyle.left;
            element.runtimeStyle.left = element.currentStyle.left;
            element.style.left = value || 0;
            value = element.style.pixelLeft + 'px';
            element.style.left = style;
            element.runtimeStyle.left = runtimeStyle;
        }

        return value;
    };
    

    window.getComputedStyle = function(el, pseudo) {
        return { 
            getPropertyValue : function(prop) {
                var re = /(\-([a-z]){1})/g;
                if (prop == 'float') { prop = 'styleFloat' };
                
                prop = prop.replace(re, function () {
                    return arguments[2].toUpperCase();
                });

                return el.currentStyle[prop] ? 
                    pixelizeDimension(el, el.currentStyle[prop]) : null;
            }
        }
    };
}

/*
 * meant as a method for <textarea/>
 * based on: http://mootools.net/docs/more/Element/Element.Forms#Element:getSelectedRange
 */
function getSelectionRange() {
    if (typeof this.selectionStart != 'undefined') {
        return [this.selectionStart, this.selectionEnd];
    }
    else if (document.selection) {

        var oTextRange = document.selection.createRange();
        var dup = oTextRange.duplicate();
        var value = this.value;
        var offset = value.length - value.match(/[\n\r]*$/)[0].length;
        dup.moveToElementText(this);
        dup.setEndPoint('StartToEnd', oTextRange);
        var end = offset - dup.text.length;
        dup.setEndPoint('StartToStart', oTextRange);
        var start = offset - dup.text.length;
        return [start, end];

    }
    else { return [0, 0] };
};

/*
 * meant as a method for <textarea/> if original not provided:
 * if (!textareaElement.setSelectionRange) {
 *     textareaElement.setSelectionRange = window.setSelectionRange
 * }
 */
function setSelectionRange(start, end) {
    var oTextRange = this.createTextRange();  // 2b modified

    oTextRange.moveStart("character", start);
    oTextRange.moveEnd("character", -(this.value.length - end));
    
    oTextRange.select();
};

/*
 * based on: http://javascript.crockford.com/memory/leak.html
 */
function purge(element, deep, properties) {
    var atts;
    if (properties) {
        for (var i = 0, prop; prop = properties[i]; ++i) {
            var propType = typeof element[prop];
            if (propType === 'function' || propType === 'object') {
                element[prop] = null;
            }
        }
    }
    else if (atts = element.attributes) {
        for (var i = 0, att; att = atts[i]; ++i) {
            var name = att.name;
            if (typeof element[name] === 'function') {
                element[name] = null;
            }
        }
    }
    
    if (!deep) { return };

    if (element.childNodes) {
        for (var i = 0, child; child = element.childNodes[i]; ++i) {
            arguments.callee(child, deep, properties);
        }
    }
};
