if (!XMLDocument.prototype.getElementsByAttribute)
    XMLDocument.prototype.getElementsByAttribute = function (name,value,tag) {
        tag = tag || '*';
        found = [];
        elements = this.getElementsByTagName(tag);
        for (var i=0, el; el = elements[i]; ++i)
            if (el.getAttribute(name) == value)
                found.push(el);
                
        return (found.length)?found:[null];
    };

if (!String.prototype.linkify)
    /*
     * Based on: http://snippets.dzone.com/posts/show/6995
     */
    String.prototype.linkify = function(options) {
        if (!options) options = {};
        if (!options.limit) options.limit = 20;
        if (!options.attributes) options.attributes = '';
        
        var regex = /(http:\/\/|https:\/\/|ftp:\/\/|www\.)\S+/gi;

        var linkified = this.replace(regex, function(str) {
            //str = str.toLowerCase(); Do not lowercase URL's they break...
            var result = str.match(/^([a-z]+:\/\/)/);
            
            var link, url;
            if (result) {
                link = str.replace(result[1],'');
                url = str;
            } else {
                link = str;
                url = 'http://' + str;
            }
        
            return '<a href="' + url + '"' + (
                    options.attributes != '' ? (' ' + options.attributes) : ''
                ) + '>' + ( 
                    link.length <= options.limit ? link
                    : (link.substr(0, options.limit - 3) + '...') 
                ) + '</a>';
        });
        
        return linkified;
    };

/*
 * http://javascript.crockford.com/remedial.html
 */    
if (!String.prototype.entityify)    
    String.prototype.entityify = function () {
        return this.replace(/&/g, "&amp;").replace(/</g,
            "&lt;").replace(/>/g, "&gt;");
    };

/*
 * turns String (request.body) into object like request.bodyItems
 */    
function toBodyItems(sBody) {
    if (!sBody)
        return {};
    var oItems = {}
    var aBody = sBody.split('&');
    var i, a;
    for (i in aBody) {
        a = aBody[i].split('=');
        if ( a[0] in oItems ) {
            oItems[a[0]].push(a[1])
        } else
            oItems[a[0]] = [a[1]];
    }
    return oItems;
};


/**
 * Constructs a new Notifier object.
 *
 * @class Notifier provides a method for showing notifications (it uses
 * widget.showNotification()). 
 * Notification that happen whithin a predefined interval are handled together.
 * ATM Opera shows only one line of notification messages; all the content may 
 * be viewed in error console on callback.
 * @constructor
 * @return A new notifier
 */
function Notifier() {
    var MIN_INTERVAL = 5000;
    var messages = [];
    
    var notifying = false;
            
    function notify(msg) {

        if (msg) { messages.push(msg); }

        if (messages.length) {

            if (notifying) { return; }

            notifying = true;
            
            // wait a mo: maybe some other notification will be pushed,
            // then show them all together
            setTimeout(function() {
                msg = messages.join(' \n'); // \n works for console
                messages = [];
				widget.getAttention();
                widget.showNotification(msg, function() { opera.postError(msg)} );
                notifying = false;
                notify();
            }, MIN_INTERVAL);
            
        }
    };

    this.notify = notify;
};